diff --git a/xlators/cluster/dht/src/dht-common.c b/xlators/cluster/dht/src/dht-common.c
index c75ad84a42c..3a1138262ee 100644
--- a/xlators/cluster/dht/src/dht-common.c
+++ b/xlators/cluster/dht/src/dht-common.c
@@ -3009,23 +3009,26 @@ dht_should_lookup_everywhere(xlator_t *this, dht_conf_t *conf, loc_t *loc)
 
     if (conf->lookup_optimize) {
         if (!conf->defrag && loc->parent) {
-            ret = dht_inode_ctx_layout_get(loc->parent, this, &parent_layout,
-                                           0);
+            ret = dht_inode_ctx_layout_get(loc->parent, this, &parent_layout);
             if (!ret && parent_layout &&
                 (parent_layout->commit_hash == conf->vol_commit_hash)) {
                 lookup_everywhere = _gf_false;
             }
+            if (!ret)
+                dht_layout_unref(parent_layout);
         }
         goto out;
     } else {
         if (conf->search_unhashed == GF_DHT_LOOKUP_UNHASHED_AUTO) {
             if (loc->parent) {
                 ret = dht_inode_ctx_layout_get(loc->parent, this,
-                                               &parent_layout, 0);
+                                               &parent_layout);
                 if (ret || !parent_layout ||
                     (!parent_layout->search_unhashed)) {
                     lookup_everywhere = _gf_false;
                 }
+                if (!ret)
+                    dht_layout_unref(parent_layout);
             } else {
                 lookup_everywhere = _gf_false;
             }
@@ -11196,8 +11199,7 @@ dht_notify(xlator_t *this, int event, void *data, ...)
 }
 
 int
-dht_inode_ctx_layout_get(inode_t *inode, xlator_t *this, dht_layout_t **layout,
-                         int ref)
+dht_inode_ctx_layout_get(inode_t *inode, xlator_t *this, dht_layout_t **layout)
 {
     dht_inode_ctx_t *ctx = NULL;
     int ret = -1;
@@ -11209,11 +11211,12 @@ dht_inode_ctx_layout_get(inode_t *inode, xlator_t *this, dht_layout_t **layout,
         if (!ret) {
             ctx = (dht_inode_ctx_t *)(uintptr_t)ctx_int;
             if (ctx && ctx->layout) {
-                if (layout)
+                if (layout) {
                     *layout = ctx->layout;
-                if (ref)
                     GF_ATOMIC_INC((*layout)->ref);
-                ret = 0;
+                }
+            } else {
+                ret = -1;
             }
         }
     }
diff --git a/xlators/cluster/dht/src/dht-common.h b/xlators/cluster/dht/src/dht-common.h
index 60a1f0c7d2a..eabb1ebe2fd 100644
--- a/xlators/cluster/dht/src/dht-common.h
+++ b/xlators/cluster/dht/src/dht-common.h
@@ -673,7 +673,7 @@ typedef struct dht_fd_ctx {
 #define ENTRY_MISSING(op_ret, op_errno) (op_ret == -1 && op_errno == ENOENT)
 
 #define is_revalidate(loc)                                                     \
-    (dht_inode_ctx_layout_get((loc)->inode, this, NULL, 0) == 0)
+    (dht_inode_ctx_layout_get((loc)->inode, this, NULL) == 0)
 
 #define is_last_call(cnt) (cnt == 0)
 
@@ -1147,10 +1147,11 @@ gf_defrag_handle_hardlink(xlator_t *this, loc_t *loc, int *fop_errno);
 
 int
 dht_inode_ctx_layout_get(inode_t *inode, xlator_t *this,
-                         dht_layout_t **layout_int, int ref);
+                         dht_layout_t **layout_int);
 int
 dht_inode_ctx_layout_set(inode_t *inode, xlator_t *this,
-                         dht_layout_t *layout_int);
+                         dht_layout_t *layout_int, dht_layout_t **old_layout,
+                         int ref);
 int
 dht_inode_ctx_time_update(inode_t *inode, xlator_t *this, struct iatt *prestat,
                           struct iatt *poststat);
diff --git a/xlators/cluster/dht/src/dht-helper.c b/xlators/cluster/dht/src/dht-helper.c
index ce909ff2fe8..2d3f34115f2 100644
--- a/xlators/cluster/dht/src/dht-helper.c
+++ b/xlators/cluster/dht/src/dht-helper.c
@@ -1788,7 +1788,8 @@ dht_rebalance_in_progress_check(xlator_t *this, call_frame_t *frame)
 
 int
 dht_inode_ctx_layout_set(inode_t *inode, xlator_t *this,
-                         dht_layout_t *layout_int)
+                         dht_layout_t *layout_int, dht_layout_t **old_layout,
+                         int ref)
 {
     dht_inode_ctx_t *ctx = NULL;
     int ret = -1;
@@ -1800,6 +1801,8 @@ dht_inode_ctx_layout_set(inode_t *inode, xlator_t *this,
         if (!ret) {
             ctx = (dht_inode_ctx_t *)(uintptr_t)ctx_int;
             if (ctx) {
+                if (ctx->layout && old_layout)
+                    (*old_layout) = ctx->layout;
                 ctx->layout = layout_int;
             }
         }
@@ -1814,6 +1817,8 @@ dht_inode_ctx_layout_set(inode_t *inode, xlator_t *this,
                     GF_FREE(ctx);
             }
         }
+        if (!ret && layout_int && ref)
+            GF_ATOMIC_INC(layout_int->ref);
     }
     UNLOCK(&inode->lock);
 
diff --git a/xlators/cluster/dht/src/dht-layout.c b/xlators/cluster/dht/src/dht-layout.c
index de39e572410..013eabef2f2 100644
--- a/xlators/cluster/dht/src/dht-layout.c
+++ b/xlators/cluster/dht/src/dht-layout.c
@@ -56,7 +56,7 @@ dht_layout_get(xlator_t *this, inode_t *inode)
 {
     dht_layout_t *layout = NULL;
 
-    dht_inode_ctx_layout_get(inode, this, &layout, 1);
+    dht_inode_ctx_layout_get(inode, this, &layout);
 
     return layout;
 }
@@ -66,48 +66,17 @@ dht_layout_set(xlator_t *this, inode_t *inode, dht_layout_t *layout)
 {
     dht_conf_t *conf = NULL;
     int ret = -1;
-    uint64_t ctx_int = 0;
-    dht_inode_ctx_t *ctx = NULL;
     dht_layout_t *old_layout = NULL;
 
     conf = this->private;
     if (!conf || !layout)
         goto out;
 
-    LOCK(&inode->lock);
-    {
-        ret = __inode_ctx_get(inode, this, &ctx_int);
-        if (!ret) {
-            ctx = (dht_inode_ctx_t *)(uintptr_t)ctx_int;
-            if (ctx && ctx->layout) {
-                old_layout = ctx->layout;
-            }
-        }
-
-        if (ctx) {
-            ctx->layout = layout;
-        } else {
-            ctx = GF_CALLOC(1, sizeof(*ctx), gf_dht_mt_inode_ctx_t);
-            if (!ctx) {
-                ret = -1;
-            } else {
-                ctx->layout = layout;
-                ctx_int = (long)ctx;
-                ret = __inode_ctx_set0(inode, this, &ctx_int);
-            }
-        }
-
-        if (!ret && layout)
-            GF_ATOMIC_INC(layout->ref);
-    }
-    UNLOCK(&inode->lock);
+    ret = dht_inode_ctx_layout_set(inode, this, layout, &old_layout, 1);
 
     if (old_layout)
         dht_layout_unref(old_layout);
 
-    if (ret)
-        GF_FREE(ctx);
-
 out:
     return ret;
 }
@@ -737,7 +706,7 @@ dht_layout_preset(xlator_t *this, xlator_t *subvol, inode_t *inode)
     gf_msg_debug(this->name, 0, "file = %s, subvol = %s",
                  uuid_utoa(inode->gfid), subvol ? subvol->name : "<nil>");
 
-    ret = dht_inode_ctx_layout_set(inode, this, layout);
+    ret = dht_inode_ctx_layout_set(inode, this, layout, NULL, 0);
 
 out:
     return ret;
diff --git a/xlators/cluster/dht/src/dht-shared.c b/xlators/cluster/dht/src/dht-shared.c
index b6663d60c7f..99147e4d5ac 100644
--- a/xlators/cluster/dht/src/dht-shared.c
+++ b/xlators/cluster/dht/src/dht-shared.c
@@ -161,7 +161,7 @@ dht_inodectx_dump(xlator_t *this, inode_t *inode)
     if (!inode)
         goto out;
 
-    ret = dht_inode_ctx_layout_get(inode, this, &layout, 0);
+    ret = dht_inode_ctx_layout_get(inode, this, &layout);
 
     if ((ret != 0) || !layout)
         return ret;
@@ -169,6 +169,8 @@ dht_inodectx_dump(xlator_t *this, inode_t *inode)
     gf_proc_dump_add_section("xlator.cluster.dht.%s.inode", this->name);
     dht_layout_dump(layout, "layout");
 
+    if (!ret)
+        dht_layout_unref(layout);
 out:
     return ret;
 }
